//------------------------------------------------------------------------------
// File: CompressorPlugin.h
//------------------------------------------------------------------------------

#ifndef __COMPRESSOR_PLUGIN__
#define __COMPRESSOR_PLUGIN__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifdef BUILD_COMPRESSOR
	#define _DLLCLASS __declspec( dllexport )
#else
	#define _DLLCLASS __declspec( dllimport )
#endif

#define DRC_LIGHT	0
#define DRC_NORMAL	1
#define DRC_STRONG	2

class _DLLCLASS Compressor
{
	// gain control
	int m_target;
	int m_gainmax;
	int m_gainsmooth;
	int m_gainCurrent, m_gainTarget;
			
	// bucket control
	long m_currentBucketPeak;
	int m_samplesInCurrentBucket;
	int m_samplesPerBucket;

	// peaks and peak position
	long *m_peaks;
	int m_pn;
	
	// number of clipped samples and anticlip control
	bool m_anticlip;
	int m_clip;
	
public:
	Compressor();
	~Compressor();

	void SetParameters(int samplesPerSec, int effect);
	
	double GetCurrentGain();
	int GetClipCount() { return m_clip; }

	void ProcessFlow32(long *input, long *output, int sampleCount);
	void ProcessFlow24(void *input, void *output, int sampleCount);
	void ProcessFlow16(short *input, short *output, int sampleCount);
	void ProcessFlow8(unsigned char *input, unsigned char *output, int sampleCount);
};

#endif // __COMPRESSOR_PLUGIN__
